# coding: utf-8

"""
    Slurm Rest API

    API to access and control Slurm.

    The version of the OpenAPI document: 0.0.38
    Contact: sales@schedmd.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from openapi_client.models.v0038_node_allocation_sockets import V0038NodeAllocationSockets
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class V0038NodeAllocation(BaseModel):
    """
    V0038NodeAllocation
    """ # noqa: E501
    memory: Optional[StrictInt] = Field(default=None, description="amount of assigned job memory")
    cpus: Optional[StrictInt] = Field(default=None, description="number of assigned job CPUs")
    sockets: Optional[V0038NodeAllocationSockets] = None
    nodename: Optional[StrictStr] = Field(default=None, description="node name")
    __properties: ClassVar[List[str]] = ["memory", "cpus", "sockets", "nodename"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of V0038NodeAllocation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sockets
        if self.sockets:
            _dict['sockets'] = self.sockets.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of V0038NodeAllocation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "memory": obj.get("memory"),
            "cpus": obj.get("cpus"),
            "sockets": V0038NodeAllocationSockets.from_dict(obj.get("sockets")) if obj.get("sockets") is not None else None,
            "nodename": obj.get("nodename")
        })
        return _obj


