# coding: utf-8

"""
    Slurm Rest API

    API to access and control Slurm.

    The version of the OpenAPI document: 0.0.38
    Contact: sales@schedmd.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr, field_validator
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class V0038Ping(BaseModel):
    """
    V0038Ping
    """ # noqa: E501
    hostname: Optional[StrictStr] = Field(default=None, description="slurm controller hostname")
    ping: Optional[StrictStr] = Field(default=None, description="slurm controller host up")
    mode: Optional[StrictStr] = Field(default=None, description="slurm controller mode")
    status: Optional[StrictInt] = Field(default=None, description="slurm controller status")
    __properties: ClassVar[List[str]] = ["hostname", "ping", "mode", "status"]

    @field_validator('ping')
    def ping_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('UP', 'DOWN'):
            raise ValueError("must be one of enum values ('UP', 'DOWN')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of V0038Ping from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of V0038Ping from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hostname": obj.get("hostname"),
            "ping": obj.get("ping"),
            "mode": obj.get("mode"),
            "status": obj.get("status")
        })
        return _obj


